<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- This file has been generated by tj3man v3.1.0 -->
<html lang="en" xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>Rich_Text_Attributes</title>
  <meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
 </head>
 <link href="css/tjmanual.css" rel="stylesheet" type="text/css"></link>
 <body>
  <div align="center">
   <h3 align="center">The TaskJuggler User Manual</h3>
   <em align="center">Project Management beyond Gantt Chart Drawing</em>
  </div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="The_TaskJuggler_Syntax.html">The_TaskJuggler_Syntax</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="Software.html">Software</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div style="width:90%; margin-left:5%; margin-right:5%"><div class="manual">
    <h2 class="manual" id="Rich_Text_Attributes">5.4 Rich Text Attributes</h2>
    <p class="manual">TaskJuggler supports Rich Text data for some STRING attributes that are marked accordingly in the syntax reference. Rich Text means, that you can use certain markup symbols to structure the text into sections, include headlines, bullet lists and the like. The following sections describe the supported markup elements and how to use them.</p>
    <p class="manual">The markup syntax is mostly compatible to the syntax used by the popular <a href="http://www.mediawiki.org" target="_top">MediaWiki</a>.</p>
    <h3 class="manual" id="Block_Markups">5.4.1 Block Markups</h3>
    <p class="manual">All block markups are delimited by an empty line. The markup must always start at the beginning of the first line of the block. Block markups cannot be nested.</p>
    <p class="manual">The simplest form of a block is a paragraph. It's a block of text that is separated by empty lines from other blocks. There is no markup needed to start a text block.</p>
    <p class="manual">Headlines can be inserted by using <code class="manual">=</code> characters to start a line. There are 3 level of headlines.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">== Headline Level 1 ==
=== Headline Level 2 ===
==== Headline Level 3 ====
</pre></div>
    <p class="manual">A line that starts with four dashes creates a horizontal line.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">----
</pre></div>
    <p class="manual">Items of a bullet list start with a star. The number of stars determines the bullet list level of the item. Three levels are supported. Bullet items may span multiple lines but cannot contain paragraphs.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">* Bullet 1
** Bullet 2
*** Bullet 3
</pre></div>
    <p class="manual">Enumerated lists are formed by using a <code class="manual">#</code> instead of <code class="manual">*</code>.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"># Enumeration Level 1
## Enumeration Level 2
### Enumeration Level 3
</pre></div>
    <p class="manual">Sections of lines that start with a space character are interpreted as pre-formatted text. The formatting will be preserved by using a fixed-width font and by not interpreting any markup characters within the text.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> Preformatted text start with
 a single space at the start of 
 each line.
</pre></div>
    <h3 class="manual" id="InLine_Markups">5.4.2 In-Line Markups</h3>
    <p class="manual">In-line markups may occur within a text block. They don't have to start at the start of the line.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">This is an ''italic'' word.
This is a '''bold''' word.
This is a ''''monospaced'''' word.
This is a '''''italic and bold''''' word.
</pre></div>
    <p class="manual">The monospace format is not part of the original MediaWiki markup, but we found it useful to have for this manual.</p>
    <p class="manual">Text can be colored when enclosed in <code class="manual">fcol</code> tags.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">This is a &lt;fcol:green&gt;green&lt;/fcol&gt; word.
</pre></div>
    <p class="manual">The following colors are supported: black, maroon, green, olive, navy, purple, teal, silver, gray, red, lime, yellow, blue, fuchsia, aqua and white.</p>
    <p class="manual">Alternatively, a hash sign followed by a 3 or 6 digit hexadecimal number can be used as well. The hexadecimal number specifies the values for the red, green and blue component of the color (i. e., #FFF for white).</p>
    <p class="manual">Links to external documents are possible as well. In the first form, the URL will appear in the readable text as well. In the second form, the text after the URL will be visible but the link will be available if the output format supports it.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">[http://www.taskjuggler.org]
[http://www.taskjuggler.org The TaskJuggler Web Site]
</pre></div>
    <p class="manual">For local references, the second form is available as well. In this form, <code class="manual">.html</code> is appended to the first word in the reference to create the URL.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">[[item]]
[[item|An item]]
</pre></div>
    <p class="manual">Images can be added with a similar syntax.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">[[File:image.jpg]]
[[File:image.jpg|alt=An image]]
</pre></div>
    <p class="manual">This first version will be replaced with the file <code class="manual">image.jpg</code> when the output format supports this. Otherwise a blank space will be inserted. The second version inserts the text <code class="manual">An image</code> if the output format does not support images. The following image types are supported and detected by their file name extensions: <code class="manual">.jpg</code>, <code class="manual">.gif</code>, <code class="manual">.png</code> and <code class="manual">.svg</code>.</p>
    <p class="manual">The vertical positioning of the embedded file can be controlled with additional attributes.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">[[File:image.svg|text-bottom]]
</pre></div>
    <p class="manual">The following attributes are supported: <code class="manual">top, middle, bottom, baseline, sub, super, text-top, text-bottom</code>.</p>
    <p class="manual">In some situations, it is desirable to not interpret certain markup sequences and reproduce the text verbatim. Such text must be enclosed in nowiki tags.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">&lt;nowiki&gt; This is not '''bold''' text. &lt;/nowiki&gt;
</pre></div>
    <h3 class="manual" id="Block_and_Inline_Generators">5.4.3 Block and Inline Generators</h3>
    <p class="manual">Block and inline generators are a very powerful extension that allow you to insert arbitrarily complex content. Block generators create a text block whereas inline generators generate an element that fits inside a text paragraph.</p>
    <p class="manual">Block generators use the following syntax:</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">&lt;[generator_name parameter1="value1" ... ]&gt;
</pre></div>
    <p class="manual">Inline generators have a very similar syntax:</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">&lt;-generator_name parameter1="value1" ... -&gt;
</pre></div>
    <p class="manual">Each generator is identified by a name. See the following list for supported generators and their functionality. Generators can have one or more optional parameters. Some parameters are mandatory, other are optional. The value of a parameter must be enclosed in single or double quotes. Since your rich text content must already be enclosed by double or single quotes, make sure you don't use the same quoting marks for the parameter value. Alternatively you can put a backslash in front of the quote mark to escape it.</p>
    <hr class="manual"/>
    <p class="manual">
     <b>Block Generator</b> <code class="manual">navigator</code>
    </p>
    <p class="manual">Parameters:</p>
    <ul><li>
      <code class="manual">id</code> : ID of a defined <a href="navigator.html">navigator</a>
     </li></ul>
    <p class="manual">The navigator generator inserts the referenced navigator.</p>
    <hr class="manual"/>
    <p class="manual">
     <b>Block Generator</b> <code class="manual">report</code>
    </p>
    <p class="manual">Paramters:</p>
    <ul><li>
      <code class="manual">id</code> : ID of a defined report</li></ul>
    <p class="manual">The report generator inserts the referenced report as a new block of this text. The referenced report inherits some context such as the report period and the property set from the referencing report.</p>
    <hr class="manual"/>
    <p class="manual">
     <b>Inline Generator</b> <code class="manual">reportlink</code>
    </p>
    <p class="manual">Paramters:</p>
    <ul><li>
      <code class="manual">id</code> : ID of a defined report</li></ul>
    <ul><li>
      <code class="manual">attributes</code>: A set of attributes that override the original attributes of the referenced report. All report attributes are supported. Since the value of attributes already must be enclosed by single or double quotes, all single or double quotes contained in the string must be escaped with backslashes. This feature enables reports with content that is customized based on where they have been referenced from. It requires the reports to be dynamically generated and is only available when used with the <code class="manual">tj3d</code> web server. The <code class="manual">tj3</code> application will ignore the attributes setting.</li></ul>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">taskreport "All" {
  formats html
  columns name { 
    celltext 1 -8&lt;-
      &lt;-query attribute="name"-&gt; &lt;-reportlink id="taskRep"
                   attributes="hidetask plan.id != \"&lt;-id-&gt;\""-&gt;
      -&gt;8-
  }, start, end
}
taskreport taskRep "Task" {
  formats html
} 
</pre></div>
    <p class="manual">The report link generator inserts a link to the referenced report.</p>
    <hr class="manual"/>
    <p class="manual">
     <b>Inline Generator</b> <code class="manual">query</code>
    </p>
    <p class="manual">Paramters:</p>
    <ul><li>
      <code class="manual">family</code> : Specifies whether a <code class="manual">task</code> or a <code class="manual">resource</code> should be queried.</li></ul>
    <ul><li>
      <code class="manual">property</code> : The ID of the task or resource to be queried. If no property is specified, the query will return a global project attribute.</li></ul>
    <ul><li>
      <code class="manual">scopeproperty</code> : The ID of the scope property. If the property is a task this must be a resource ID and vice versa.</li></ul>
    <ul><li>
      <code class="manual">attribute</code> : The ID of the attribute which value should be returned by the query. If a property ID is provided, this must be one of the names that can be used as <a href="columnid.html">columnid</a> values. Without a property, global attributes of the project can be requested. The following attributes are supported: <code class="manual">copyright</code>, <code class="manual">currency</code>, <code class="manual">end</code>, <code class="manual">name</code>, <code class="manual">now</code>, <code class="manual">projectid</code>, <code class="manual">start</code> and <code class="manual">version</code>.</li></ul>
    <ul><li>
      <code class="manual">scenario</code> : The ID of a scenario. This must be provided whenever the requested attribute is scenario specific.</li></ul>
    <ul><li>
      <code class="manual">start</code> : The start date of the report period of the current report.</li></ul>
    <ul><li>
      <code class="manual">end</code> : The end date of the report period of the current report.</li></ul>
    <ul><li>
      <code class="manual">loadunit</code> : The <a href="loadunit.html">loadunit</a> that should be used in case the requested attribute is an effort or duration value.</li></ul>
    <ul><li>
      <code class="manual">timeformat</code> : The <a href="timeformat.html">timeformat</a> used to format date attributes.</li></ul>
    <ul><li>
      <code class="manual">numberformat</code> : The <a href="numberformat.html">numberformat</a> used to format arithmetic attributes.</li></ul>
    <ul><li>
      <code class="manual">currencyformat</code> : The <a href="currencyformat.html">currencyformat</a> used to format currency values.</li></ul>
    <p class="manual">The query generator inserts any requested value from the project, a task or a resource.</p>
    <p class="manual">Queries are context aware. Depending on the context where the query is used, certain or all of the above parameters have already predefined values. When used in the header section of a report, the context does not provide a property or scope property. Start and end dates as well the formatting options are taken from the report context. But when used e. g. in <a href="celltext.column.html">celltext.column</a> the cell provides, that property and the attribute and possibly even the scope property.</p>
   </div></div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="The_TaskJuggler_Syntax.html">The_TaskJuggler_Syntax</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="Software.html">Software</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div align="center" style="font-size:10px;">Copyright (c) 2006, 2007, 2008, 2009, 2010, 2011, 2012 by Chris Schlaeger &lt;chris@linux.com&gt;.<a href="http://www.taskjuggler.org">TaskJuggler</a> is a trademark of Chris Schlaeger.</div>
 </body>
</html>
